project/accounts/urls.py
from django.urls import path

from project.accounts import views

app_name = 'account'

urlpatterns = [
    path('logout/', views.logout_view, name='logout'),
    path('profile/', views.ProfileView.as_view(), name='profile'),
    path('<uidb64>/<token>/', views.TokenAuthView.as_view(), name='activate'),
]

project/bot/urls.py
from django.urls import path

from project.bot import views

urlpatterns = [
    path('', views.TelegramBot.as_view()),
]

project/landing/urls.py
from django.urls import path

from project.landing import views

app_name = 'landing'

urlpatterns = [
    path('', views.LandingView.as_view(), name='landing'),
]

project/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('project.landing.urls')),
    path('account/', include('project.accounts.urls')),
    path('telegram/', include('project.bot.urls')),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

project/accounts/models.py
from django.contrib.auth.models import AbstractUser, UserManager
from django.db import models
from imagekit.models import ImageSpecField
from pilkit.processors import ResizeToFill

from project.utils.validators import FileExtValidator


class User(AbstractUser):
    bot_id = models.CharField('Telegram ID', max_length=30, blank=True)

    objects = UserManager()

project/accounts/forms.py
from django import forms

from project.accounts.models import User


class ProfileForm(forms.ModelForm):
    """
    Форма профиля в личном кабинете
    """

    class Meta:
        model = User
        fields = (
            'first_name',
            'last_name',
        )

    def update_profile(self, user):
        cd = self.cleaned_data

        user.first_name = cd['first_name']
        user.last_name = cd['last_name']
        user.save()

project/accounts/views.py
from django.contrib.auth import login
from django.contrib.auth import logout
from django.contrib.auth.decorators import login_required
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.tokens import default_token_generator
from django.shortcuts import redirect
from django.urls import reverse
from django.utils.encoding import force_text
from django.utils.http import urlsafe_base64_decode
from django.views.generic import FormView, RedirectView

from project.accounts.forms import ProfileForm
from project.accounts.models import User


@login_required
def logout_view(request):
    logout(request)
    return redirect('landing:landing')


class TokenAuthView(RedirectView):
    """
    Авторизация по токену
    """

    def get(self, request, *args, **kwargs):
        if request.headers['User-Agent'] == 'TelegramBot (like TwitterBot)':
            return False
        return super().get(request, *args, **kwargs)

    def get_redirect_url(self, *args, **kwargs):
        uidb64 = self.kwargs.get('uidb64')
        token = self.kwargs.get('token')

        url = reverse('landing:landing')

        try:
            uid = force_text(urlsafe_base64_decode(uidb64))
            user = User.objects.get(pk=uid)
        except(TypeError, ValueError, OverflowError, User.DoesNotExist):
            pass
        else:
            if default_token_generator.check_token(user, token):
                login(self.request, user)
                url = '/account/profile/'
            else:
                logout(self.request)

        return url


class ProfileView(LoginRequiredMixin, FormView):
    """
    Страница профиля пользователя
    """

    template_name = 'accounts/profile.html'
    form_class = ProfileForm
    success_url = '/account/profile/'

    def get_initial(self):
        initial = super().get_initial()

        user = self.request.user
        initial.update({
            'first_name': user.first_name,
            'last_name': user.last_name,
        })

        return initial

    def form_valid(self, form):
        form.update_profile(self.request.user)
        return super().form_valid(form)

project/bot/views.py
from pprint import pprint
from django.conf import settings
from django.http import JsonResponse
from django.utils.decorators import method_decorator
from django.views.decorators.csrf import csrf_exempt
from django.views.generic.base import View

from project.bot.bot_methods import post_telegram_data
from project.bot.utils import get_payload, get_value, get_or_create_user, get_login_link


@method_decorator(csrf_exempt, name="dispatch")
class TelegramBot(View):
    """
    WebHook для Telegram
    """

    def post(self, request, *args, **kwargs):
        payload = get_payload(request)

        if payload:
            if get_value(payload, "message.text") == '/start':
                # Подписка на бота
                get_or_create_user(payload=payload, token=settings.TELEGRAM['TOKEN'])
                post_telegram_data(
                    token=settings.TELEGRAM['TOKEN'],
                    method='sendMessage',
                    data={
                        'chat_id': get_value(payload, "message.chat.id"),
                        'text': 'Привет!',
                    }
                )

            elif get_value(payload, "message.text") == '/login':
                # Запрос ссылки на взод в лк
                login_link = get_login_link(payload=payload, token=settings.TELEGRAM['TOKEN'])
                post_telegram_data(
                    token=settings.TELEGRAM['TOKEN'],
                    method='sendMessage',
                    data={
                        'chat_id': get_value(payload, "message.chat.id"),
                        'text': login_link,
                    }
                )

            else:
                # Эхо-сообщение
                post_telegram_data(
                    token=settings.TELEGRAM['TOKEN'],
                    method='sendMessage',
                    data={
                        'chat_id': get_value(payload, "message.chat.id"),
                        'text': get_value(payload, "message.text"),
                    }
                )

        return JsonResponse({}, status=200)

project/landing/views.py
from django.views.generic import TemplateView


class LandingView(TemplateView):
    """
    Лэндинг
    """
    template_name = 'landing/index.html'

templates/accounts/profile.html
{% extends 'base.html' %}
{% load static %}

{% block styles %}{% endblock styles %}
{% block scripts %}{% endblock scripts %}
{% block title %}Мой профиль{% endblock title %}
{% block content %}
    <div class="content" style="padding: 20px 25px 150px;">
        <div class="uk-grid uk-child-width-expand@s" uk-grid>
            <div class="uk-width-1-3@m">
                <div class="uk-card uk-card-default" style="min-width: 280px;">
                    <div class="uk-card-media-top uk-text-center">
                        <div class="uk-card-body">
                            <h5 class="uk-text-bold uk-text-center">Telegram ID: {{ request.user.bot_id }}</h5>
                            <hr>
                            <p class="uk-text-small uk-margin-remove-bottom uk-text-center">Последний вход:<br><span
                                    class="uk-text-secondary">{{ request.user.last_login|date }}</span>
                            </p>
                        </div>
                    </div>
                </div>
            </div>
            <div class="uk-width-expand@m">
                <div class="uk-card uk-card-default uk-card-small uk-card-body">
                    <form class="uk-form-stacked" method="post" enctype="multipart/form-data">
                        {% csrf_token %}
                        <div>
                            <label class="uk-form-label" for="form-stacked-text">Фамилия:</label>
                            <div class="uk-form-controls">
                                <input class="uk-input" id="id_last_name" type="text" name="last_name"
                                       placeholder="Фамилия" maxlength="150"
                                       value="{{ form.last_name.value }}">
                            </div>
                        </div>
                        <div class="uk-margin">
                            <label class="uk-form-label" for="form-stacked-text">Имя:</label>
                            <div class="uk-form-controls">
                                <input class="uk-input" id="id_first_name" type="text" name="first_name"
                                       placeholder="Имя" maxlength="30"
                                       value="{{ form.first_name.value }}">
                            </div>
                        </div>
                        <button type="submit" class="uk-button uk-button-default">СОХРАНИТЬ</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <div id="modal-center" class="uk-flex-top" uk-modal>
        <div class="uk-modal-dialog uk-modal-body uk-margin-auto-vertical">
            <button class="uk-modal-close-default" type="button" uk-close></button>
            <p id="for-message" class="uk-text-center"></p>
        </div>
    </div>
{% endblock content %}

templates/base.html
{% load static %}

<!DOCTYPE HTML>
<html lang="ru">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width,initial-scale=1.0">
    <title>{% block title %}MLM Test Project{% endblock %}</title>
    <link rel="stylesheet" href="{% static 'uikit/css/uikit.min.css' %}"/>
    <script src="{% static 'uikit/js/uikit.min.js' %}"></script>
    <script src="{% static 'uikit/js/uikit-icons.min.js' %}"></script>
    <link rel="stylesheet" href="{% static 'scss/style.css' %}"/>
</head>
<body>

{% include 'header.html' %}
{% block content %}{# Основной контент сайта #}{% endblock %}
{% include 'footer.html' %}

</body>
</html>

templates/footer.html
<div class="footer">
    <div class="content uk-text-center">
        <small>© {% now 'Y' %} MLM Test Project</small>
    </div>
</div>

templates/header.html
{% load static %}
<div class="header"
     uk-sticky="sel-target: .uk-navbar-container; cls-active: uk-navbar-sticky; bottom: #transparent-sticky-navbar">
    <nav class="uk-navbar-container header" uk-navbar>
        <div class="uk-navbar-left">
            <ul class="uk-navbar-nav">
                <li {% if request.path == '/' %}class="uk-active"{% endif %}>
                    <a href="{% url 'landing:landing' %}">Главная</a>
                </li>
            </ul>
        </div>
        <div class="uk-navbar-right">
            <ul class="uk-navbar-nav">
                <li>
                    {% if request.user.is_authenticated %}
                        <a href="#">
                            <span class="uk-icon uk-margin-small-right" uk-icon="icon: cog"></span>Управление
                        </a>
                        <div class="uk-navbar-dropdown">
                            <ul class="uk-nav uk-navbar-dropdown-nav">
                                <li><a href="{% url 'account:profile' %}">Мой профиль</a></li>
                                <li><a href="{% url 'account:logout' %}">Выход</a></li>
                            </ul>
                        </div>
                    {% endif %}
                </li>
            </ul>
        </div>
    </nav>
</div>

templates/landing/index.html
{% extends 'base.html' %}
{% load static %}

{% block styles %}{% endblock styles %}
{% block scripts %}{% endblock scripts %}
{% block title %}{{ block.super }} | Лэндинг{% endblock title %}
{% block content %}
    <div class="uk-background-cover uk-light first-screen uk-flex uk-flex-center uk-flex-middle" data-src="{% static 'img/bg.jpg' %}" uk-img>
        <h1 class="uk-text-bolder shadow-text">MLM Test Project</h1>
    </div>
{% endblock content %}